// src/useAsync.ts
import { useEffect, useMemo, useRef, useState } from "react";
import { Async } from "@corets/async";
var useAsync = (producer, dependencies = []) => {
  const [reference, setReference] = useState(0);
  const producerRef = useRef(producer);
  producerRef.current = producer;
  const async = useMemo(() => {
    if (producerRef.current instanceof Async) {
      return producerRef.current;
    }
    return new Async(() => producerRef.current());
  }, [producerRef.current instanceof Async ? producerRef.current : void 0]);
  useEffect(() => {
    return async.listen(() => setReference((previous) => previous + 1));
  }, [async]);
  useEffect(() => {
    async.run();
  }, [...dependencies, async]);
  return async;
};
export {
  useAsync
};
//# sourceMappingURL=index.js.map
