"use strict";Object.defineProperty(exports, "__esModule", {value: true});// src/useAsync.ts
var _react = require('react');
var _async = require('@corets/async');
var useAsync = (producer, dependencies = []) => {
  const [reference, setReference] = _react.useState.call(void 0, 0);
  const producerRef = _react.useRef.call(void 0, producer);
  producerRef.current = producer;
  const async = _react.useMemo.call(void 0, () => {
    if (producerRef.current instanceof _async.Async) {
      return producerRef.current;
    }
    return new (0, _async.Async)(() => producerRef.current());
  }, [producerRef.current instanceof _async.Async ? producerRef.current : void 0]);
  _react.useEffect.call(void 0, () => {
    return async.listen(() => setReference((previous) => previous + 1));
  }, [async]);
  _react.useEffect.call(void 0, () => {
    async.run();
  }, [...dependencies, async]);
  return async;
};


exports.useAsync = useAsync;
//# sourceMappingURL=index.js.map
